﻿using System;
using Microsoft.AnalysisServices;

namespace AmoAutomation {
    class Program {
        static void MainSequential(string[] args) {
            Server server = new Server();
            server.Connect (@"localhost\TABULAR");
            server.BeginTransaction();
            Database db = server.Databases["AdventureWorks Tabular Model SQL 2012"];
            Dimension tableProduct = db.Dimensions.GetByName("Product");
            Dimension tableInternetSales = db.Dimensions.GetByName("Internet Sales");
            tableProduct.Process(ProcessType.ProcessData);
            tableInternetSales.Process(ProcessType.ProcessData);
            db.Process(ProcessType.ProcessRecalc);
            server.CommitTransaction();
            server.Disconnect();
        }
        static void Main(string[] args) {
            Server server = new Server();
            server.Connect(@"localhost\TABULAR");
            server.CaptureXml = true;
            Database db = server.Databases["AdventureWorks Tabular Model SQL 2012"];
            Dimension tableProduct = db.Dimensions.GetByName("Product");
            Dimension tableInternetSales = db.Dimensions.GetByName("Internet Sales");
            tableProduct.Process(ProcessType.ProcessData);
            tableInternetSales.Process(ProcessType.ProcessData);
            db.Process(ProcessType.ProcessRecalc);
            server.CaptureXml = false;
            server.ExecuteCaptureLog(true, true);
            server.Disconnect();
        }
    }
}

/*
 * ProcessAdd example
 * 
namespace AmoAutomation {
    class Program {
        static void Main(string[] args) {
            Server server = new Server();
            server.Connect(@"localhost\TABULAR");
            // server.BeginTransaction();
            Database db = server.Databases["AdventureWorks Tabular Model SQL 2012"];
            DataSourceView dsv = db.DataSourceViews.GetByName("Sandbox");
            Cube cube = db.Cubes.GetByName("Model");
            MeasureGroup measureGroup = cube.MeasureGroups.GetByName("Internet Sales");
            Partition partition = measureGroup.Partitions.GetByName("Internet Sales - 2006");
            partition.Process(
                ProcessType.ProcessAdd,
                new QueryBinding(
                        dsv.DataSourceID,
                        "SELECT * FROM FactInternetSales WHERE OrderDateKey >= 20120215"));
            // db.Process(ProcessType.ProcessRecalc);
            // server.CommitTransaction();
            server.Disconnect();
        }
    }
}
 *
 */
